diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 4437d04bb..998a80791 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -1,7 +1,8 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -45,39 +46,39 @@ public class ItemModelStandard extends ItemModel{
 
     protected boolean itemfullBright = false;
 
-    public ItemModelStandard(Item item, String namespace) {
+    public ItemModelStandard(final Item item, final String namespace) {
         super(item);
-        displayPosMap.put(DisplayPos.GROUND, DEFAULT_ITEM_GROUND);
-        displayPosMap.put(DisplayPos.HEAD, DEFAULT_ITEM_HEAD);
-        displayPosMap.put(DisplayPos.THIRD_PERSON_RIGHT_HAND, DEFAULT_ITEM_THIRD_PERSON_RIGHT_HAND);
-        displayPosMap.put(DisplayPos.THIRD_PERSON_LEFT_HAND, DEFAULT_ITEM_THIRD_PERSON_LEFT_HAND); // TODO make automatic since its just the axis flipped
-        displayPosMap.put(DisplayPos.FIRST_PERSON_RIGHT_HAND, DEFAULT_ITEM_FIRST_PERSON_RIGHT_HAND);
-        displayPosMap.put(DisplayPos.FIRST_PERSON_LEFT_HAND, DEFAULT_ITEM_FIRST_PERSON_LEFT_HAND); // TODO make automatic since its just the axis flipped
-        displayPosMap.put(DisplayPos.FIXED, DEFAULT_ITEM_FIXED);
+        this.displayPosMap.put(DisplayPos.GROUND, DEFAULT_ITEM_GROUND);
+        this.displayPosMap.put(DisplayPos.HEAD, DEFAULT_ITEM_HEAD);
+        this.displayPosMap.put(DisplayPos.THIRD_PERSON_RIGHT_HAND, DEFAULT_ITEM_THIRD_PERSON_RIGHT_HAND);
+        this.displayPosMap.put(DisplayPos.THIRD_PERSON_LEFT_HAND, DEFAULT_ITEM_THIRD_PERSON_LEFT_HAND); // TODO make automatic since its just the axis flipped
+        this.displayPosMap.put(DisplayPos.FIRST_PERSON_RIGHT_HAND, DEFAULT_ITEM_FIRST_PERSON_RIGHT_HAND);
+        this.displayPosMap.put(DisplayPos.FIRST_PERSON_LEFT_HAND, DEFAULT_ITEM_FIRST_PERSON_LEFT_HAND); // TODO make automatic since its just the axis flipped
+        this.displayPosMap.put(DisplayPos.FIXED, DEFAULT_ITEM_FIXED);
         if (namespace != null){
-            icon = TextureRegistry.getTexture(namespace + ":item/" + item.getKey().substring("item.".length()).replace(".", "_"));
+            this.icon = TextureRegistry.getTexture(namespace + ":item/" + item.getKey().substring("item.".length()).replace(".", "_"));
         }
     }
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX) {
+    public void render(@NotNull final Tessellator tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, final float brightness, final float alpha, final float partialTick, final boolean mirrorX) {
         random.setSeed(187L);
-        DisplayPos displayPos = getDisplayPos(displayPosId);
+        final DisplayPos displayPos = getDisplayPos(displayPosId);
         GL11.glTranslatef(displayPos.tx, displayPos.ty, displayPos.tz);
         GL11.glRotatef(displayPos.rx, 1, 0, 0);
         GL11.glRotatef(displayPos.ry, 0, 1, 0);
         GL11.glRotatef(displayPos.rz, 0, 0, 1);
         GL11.glScalef(displayPos.sx, displayPos.sy, displayPos.sz);
-        int color = getColor(itemStack);
-        float r = net.minecraft.core.util.helper.Color.redFromInt(color)/255f;
-        float g = net.minecraft.core.util.helper.Color.greenFromInt(color)/255f;
-        float b = net.minecraft.core.util.helper.Color.blueFromInt(color)/255f;
+        final int color = getColor(itemStack);
+        final float r = net.minecraft.core.util.helper.Color.redFromInt(color)/255f;
+        final float g = net.minecraft.core.util.helper.Color.greenFromInt(color)/255f;
+        final float b = net.minecraft.core.util.helper.Color.blueFromInt(color)/255f;
         GL11.glColor4f(brightness * r, brightness * g, brightness * b, alpha);
         if (items3d) {
             for (int i = 0; i < clusterSize; i++) {
-                float offX = 0;
-                float offY = 0;
-                float offZ = 0.1f * i;
+                final float offX = 0;
+                final float offY = 0;
+                final float offZ = 0.1f * i;
                 GL11.glTranslatef(offX, offY, offZ);
                 renderSingle(tessellator, holder, itemStack, true, brightness, alpha, partialTick, mirrorX);
                 GL11.glTranslatef(-offX, -offY, -offZ);
@@ -99,11 +100,11 @@ public class ItemModelStandard extends ItemModel{
         }
     }
 
-    protected void renderSingle(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, float brightness, float alpha, float partialTick, boolean mirrorX) {
+    protected void renderSingle(@NotNull final Tessellator tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, final boolean items3d, final float brightness, final float alpha, final float partialTick, final boolean mirrorX) {
         renderCoordinate(tessellator, getIcon(holder, itemStack), items3d, mirrorX);
     }
 
-    protected void renderCoordinate(@NotNull Tessellator tessellator, @NotNull IconCoordinate coordinate, boolean items3d, boolean mirrorX) {
+    protected void renderCoordinate(@NotNull final Tessellator tessellator, @NotNull final IconCoordinate coordinate, final boolean items3d, final boolean mirrorX) {
         final double cUMin = mirrorX ? coordinate.getIconUMax() : coordinate.getIconUMin();
         final double cUMax = mirrorX ? coordinate.getIconUMin() : coordinate.getIconUMax();
         final double cVMin = coordinate.getIconVMin();
@@ -125,10 +126,10 @@ public class ItemModelStandard extends ItemModel{
 
             // top bottom
             for (int h = 0; h < pxH; h++) {
-                double y1 = (double) h /pxH;
-                double y2 = (double) (h + 1) /pxH;
-                double vMin = coordinate.getSubIconV(y1);
-                double vMax = coordinate.getSubIconV(y2);
+                final double y1 = (double) h /pxH;
+                final double y2 = (double) (h + 1) /pxH;
+                final double vMin = coordinate.getSubIconV(y1);
+                final double vMax = coordinate.getSubIconV(y2);
 
                 // top
                 tessellator.setNormal(0, 1, 0);
@@ -147,12 +148,12 @@ public class ItemModelStandard extends ItemModel{
 
             // left right
             for (int w = 0; w < pxW; w++) {
-                double x1 = (double) w / pxW;
-                double x2 = (double) (w + 1) / pxW;
+                final double x1 = (double) w / pxW;
+                final double x2 = (double) (w + 1) / pxW;
 
 
-                double uMin = coordinate.getSubIconU(mirrorX ? 1 - x1 : x1);
-                double uMax = coordinate.getSubIconU(mirrorX ? 1 - x2 : x2);
+                final double uMin = coordinate.getSubIconU(mirrorX ? 1 - x1 : x1);
+                final double uMax = coordinate.getSubIconU(mirrorX ? 1 - x2 : x2);
 
                 // right
                 tessellator.setNormal(-1, 0, 0);
@@ -191,25 +192,25 @@ public class ItemModelStandard extends ItemModel{
         }
     }
 
-    public @NotNull DisplayPos getDisplayPos(@NotNull String id) {
-        return displayPosMap.getOrDefault(id, DisplayPos.DEFAULT_DISPLAY_POS);
+    public @NotNull DisplayPos getDisplayPos(@NotNull final String id) {
+        return this.displayPosMap.getOrDefault(id, DisplayPos.DEFAULT_DISPLAY_POS);
     }
 
-    public @NotNull ItemModelStandard setDisplayPos(@NotNull String id, @NotNull DisplayPos displayPos) {
+    public @NotNull ItemModelStandard setDisplayPos(@NotNull final String id, @NotNull final DisplayPos displayPos) {
         this.displayPosMap.put(id, Objects.requireNonNull(displayPos, "Display pos cannot be null!"));
         return this;
     }
 
     @Override
-    public void renderItemOverlayIntoGUI(@NotNull Tessellator tessellator, @NotNull Font font, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha) {
+    public void renderItemOverlayIntoGUI(@NotNull final Tessellator tessellator, @NotNull final FontRenderer fontRenderer, @NotNull final TextureManager textureManager, @NotNull final ItemStack itemstack, final int x, final int y, @Nullable final String override, final float alpha) {
         glEnable(GL_BLEND);
         glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         final int a = (int) (alpha * 255.0f);
         if (itemstack.stackSize != 1 || override != null) {
-            String s = override != null ? override : "" + itemstack.stackSize;
+            final String s = override != null ? override : "" + itemstack.stackSize;
             GL11.glDisable(GL_LIGHTING);
             GL11.glDisable(GL_DEPTH_TEST);
-            font.drawStringWithShadow(s, (x + 19) - 2 - font.getStringWidth(s), y + 6 + 3, 0xffffff | (a << 24));
+            FontHelper.render(tessellator, s, (x + 19) - 2 - fontRenderer.stringWidth(s), y + 6 + 3).setShadow().setColor(0xffffff | (a << 24)).call(fontRenderer);
             GL11.glEnable(GL_LIGHTING);
             GL11.glEnable(GL_DEPTH_TEST);
         }
@@ -232,7 +233,7 @@ public class ItemModelStandard extends ItemModel{
         glDisable(GL_BLEND);
     }
 
-    protected void renderColoredQuad(Tessellator tessellator, int x, int y, int width, int height, int colorRGB, int alpha) {
+    protected void renderColoredQuad(final Tessellator tessellator, final int x, final int y, final int width, final int height, final int colorRGB, final int alpha) {
         final float z = 0.0F;
         tessellator.startDrawingQuads();
         tessellator.setColorRGBA_I(colorRGB, alpha);
@@ -243,21 +244,21 @@ public class ItemModelStandard extends ItemModel{
         tessellator.draw();
     }
 
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
-        return icon;
+    public @NotNull IconCoordinate getIcon(@Nullable final Entity entity, final ItemStack itemStack){
+        return this.icon;
     }
-    public int getColor(ItemStack stack)
+    public int getColor(final ItemStack stack)
     {
         return getColorFromMeta(stack.getMetadata());
     }
-    public int getColorFromMeta(int meta)
+    public int getColorFromMeta(final int meta)
     {
         return 0xffffff;
     }
 
     public ItemModelStandard setFullBright()
     {
-        itemfullBright = true;
+        this.itemfullBright = true;
         return this;
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/TextureFile.java b/game/client/src/main/java/net/minecraft/client/render/texture/TextureFile.java
index b8a437c3f..ee65211e2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/TextureFile.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/TextureFile.java
@@ -23,63 +23,70 @@ public class TextureFile extends Texture{
         this.sourcePath = null;
     }
 
-    public TextureFile(String path) {
+    public TextureFile(final String path) {
         generate();
         this.sourcePath = path;
-        init();
     }
 
     @Override
-    public boolean hasMeta(String key) {
-        return metaHandler.has(key);
+    public boolean hasMeta(final String key) {
+        return this.metaHandler.has(key);
     }
 
     @Override
-    public @Nullable <T> T getMeta(String key, Class<T> aClass) {
-        return metaHandler.get(key, aClass);
+    public @Nullable <T> T getMeta(final String key, final Class<T> aClass) {
+        return this.metaHandler.get(key, aClass);
     }
 
     @Override
-    public <T> T getOrDefaultMeta(String key, T metaDefault, Class<T> aClass) {
-        return metaHandler.getOrDefault(key, metaDefault, aClass);
+    public <T> T getOrDefaultMeta(final String key, final T metaDefault, final Class<T> aClass) {
+        return this.metaHandler.getOrDefault(key, metaDefault, aClass);
     }
 
     @Override
     public void init() {
-        metaHandler.reset();
+        initFileTex(true);
+    }
+
+    public boolean initFileTex(final boolean defaultMissingTex) {
+        this.metaHandler.reset();
 
-        if (sourcePath != null) {
-            Minecraft mc = Minecraft.getMinecraft();
-            TexturePack pack = mc.texturePackList.getHighestPriorityTexturePackWithFile(sourcePath);
+        if (this.sourcePath != null) {
+            final Minecraft mc = Minecraft.getMinecraft();
+            final TexturePack pack = mc.texturePackList.getHighestPriorityTexturePackWithFile(this.sourcePath);
             if (pack == null) {
-                setupTexture(missingTexture);
-                return;
+                if (defaultMissingTex) setupTexture(missingTexture);
+                return false;
             }
 
-            try (InputStream stream = pack.getResourceAsStream(sourcePath + ".mcmeta")) {
+            try (final InputStream stream = pack.getResourceAsStream(this.sourcePath + ".mcmeta")) {
                 if (stream != null) {
-                    metaHandler.loadFromStream(stream);
+                    this.metaHandler.loadFromStream(stream);
                 }
-            } catch (Exception e) {
-                LOGGER.error("Failed to load data for '{}.mcmeta'!", sourcePath, e);
+            } catch (final Exception e) {
+                LOGGER.error("Failed to load data for '{}.mcmeta'!", this.sourcePath, e);
             }
 
-            try (InputStream imageStream = pack.getResourceAsStream(sourcePath)) {
+            try (final InputStream imageStream = pack.getResourceAsStream(this.sourcePath)) {
                 if (imageStream == null) {
-                    setupTexture(missingTexture);
-                    return;
+                    if (defaultMissingTex) setupTexture(missingTexture);
+                    return false;
                 }
                 setupTexture(readImage(imageStream));
-            } catch (IOException e) {
-                setupTexture(missingTexture);
+            } catch (final IOException e) {
+                if (defaultMissingTex) setupTexture(missingTexture);
+                return false;
             }
+        } else {
+            return false;
         }
+        return true;
     }
 
     @Override
     public String toString() {
-        return "Source: " + sourcePath + "\n" +
-                "Meta: \n" + metaHandler;
+        return "Source: " + this.sourcePath + "\n" +
+                "Meta: \n" + this.metaHandler;
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 6e3a23f1b..119be40f2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -4,7 +4,6 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.keyboard.KeyboardLayout;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.sound.SoundRepository;
@@ -35,13 +34,16 @@ public class TexturePackList
 	public TexturePackList(Minecraft minecraft, File file) {
 		this.mc = minecraft;
 
-		texturePackDir = new File(file, "texturepacks");
-		if(!texturePackDir.exists()) {
-			texturePackDir.mkdirs();
+        this.texturePackDir = new File(file, "texturepacks");
+		if(!this.texturePackDir.exists()) {
+            this.texturePackDir.mkdirs();
 		}
+	}
 
+	public void init() {
 		updateAvailableTexturePacks();
 	}
+
 	public void shiftPack(TexturePack pack, int shiftAmount){
 		if (!selectedPacks.contains(pack)) return;
 		if (shiftAmount == 0) return;
@@ -93,7 +95,6 @@ public class TexturePackList
 	}
 	public void refresh(){
 		mc.textureManager.refreshTexturesAndDisplayErrors();
-		mc.font = new Font(mc, mc.gameSettings, mc.textureManager);
 		mc.renderGlobal.loadRenderers();
 		if (mc.currentScreen != null) {
 			mc.currentScreen.updateFont();
@@ -231,6 +232,13 @@ public class TexturePackList
 		return selectedPacks.get(selectedPacks.size()-1);
 	}
 
+	public boolean anyHasFile(String path) {
+		for (int i = 0; i < this.selectedPacks.size(); i++) {
+			if (this.selectedPacks.get(i).hasFile(path)) return true;
+		}
+		return false;
+	}
+
 	public @Nullable TexturePack getHighestPriorityTexturePackWithFile(String path) {
 		return getHighestPriorityTexturePackWithFile(path, true);
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
index 4d41ee199..4bb35ed7d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.tileentity;
 
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
@@ -33,7 +33,7 @@ public abstract class TileEntityRenderer<T extends TileEntity>
     }
 
 
-    public Font getFont()
+    public FontRenderer getFont()
     {
         return renderDispatcher.getFont();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index bfdb6820e..bd6b3d8ea 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -1,12 +1,10 @@
 package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.model.ModelBase;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.model.ModelSign;
-import net.minecraft.client.render.model.ModelSkeleton;
-import net.minecraft.client.render.model.ModelZombie;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -31,7 +29,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
     }
 
      @Override
-	public void doRender(Tessellator tessellator, TileEntitySign tileEntity, double x, double y, double z,
+	public void doRender(Tessellator t, TileEntitySign tileEntity, double x, double y, double z,
                          float partialTick)
     {
         Block<?> block = tileEntity.getBlock();
@@ -82,7 +80,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glPopMatrix();
 
         // Render text
-        Font font = getFont();
+        FontRenderer sr = getFont();
         float lightLevel = LightmapHelper.isLightmapEnabled() ? 1 : mc.currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         float lightOffset = 0f;
         if (tileEntity.isGlowing()) {
@@ -111,7 +109,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
             {
                 text = "> " + text + " <";
             }
-            font.drawString(text, -font.getStringWidth(text) / 2, line * 10 - tileEntity.signText.length * 5, color);
+            FontHelper.render(t, text, -sr.stringWidth(text) / 2, line * 10 - tileEntity.signText.length * 5).setColor(color).call(sr);
         }
         GL11.glPopMatrix();
 
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index 8211407a3..e70b289c2 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -2,12 +2,13 @@ package net.minecraft.client.util.debug;
 
 import static org.lwjgl.opengl.GL11.*;
 
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.core.util.debug.Debug;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.Display;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.debug.Debug.Profiler;
 import net.minecraft.core.util.helper.MathHelper;
@@ -65,7 +66,7 @@ public class DebugRender {
 		resetFrametimes();
 	}
 	
-	public static void render(Font font) {
+	public static void render(FontRenderer sr) {
 		frametimes[pos] = selectedProfiler.time;
 		baseframetimes[pos] = Debug.baseProfiler.time;
 		pos++;
@@ -89,18 +90,18 @@ public class DebugRender {
 		glEnable(GL_BLEND);
 		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 		
-		Tessellator tessellator = Tessellator.instance;
+		Tessellator t = Tessellator.instance;
 		
 		int x = w - frametimes.length;
 		int y = h;
 		
 		if(selectedProfiler != Debug.baseProfiler) {
 			if(w > frametimes.length + baseframetimes.length) {
-				drawFrameTimes(tessellator, x, y, baseframetimes);
+				drawFrameTimes(t, x, y, baseframetimes);
 			}
-			drawFrameTimes(tessellator, 0, y, frametimes);
+			drawFrameTimes(t, 0, y, frametimes);
 		}else {
-			drawFrameTimes(tessellator, 0, y, baseframetimes);
+			drawFrameTimes(t, 0, y, baseframetimes);
 		}
 
 		glDisable(GL_BLEND);
@@ -118,10 +119,10 @@ public class DebugRender {
 		
 		int fps = Debug.getFps();
 		if(fps >= 0) {
-			font.drawString("fps: " + fps, x1, y1 - 2 * lineHeight, 0xFFFFFFFF);
+			FontHelper.render(t, "fps: " + fps, x1, y1 - 2 * lineHeight).call(sr);
 		}
-		font.drawString("avg: " + (getAvgTime(frametimes) / 1000.0) + " ms", x1, y1 - lineHeight, 0xFFFFFFFF);
-		font.drawString(selectedProfiler.name + ": ", x1, y1, 0xFFFFFFFF);
+		FontHelper.render(t, "avg: " + (getAvgTime(frametimes) / 1000.0) + " ms", x1, y1 - lineHeight).call(sr);
+		FontHelper.render(t, selectedProfiler.name + ": ", x1, y1).call(sr);
 		for(int i=0; i < selectedProfiler.allProfilers.size(); i++) {
 			Profiler profiler = selectedProfiler.allProfilers.get(i);
 
@@ -129,7 +130,7 @@ public class DebugRender {
 			if(i == selection) {
 				color = 0xFF00FFFF;
 			}
-			font.drawString(i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight, color);
+			FontHelper.render(t, i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight).setColor(color).call(sr);
 		}
 		glEnable(GL_ALPHA_TEST);
 	}
diff --git a/game/client/src/test/java/TestItemModelDispatcher.java b/game/client/src/test/java/TestItemModelDispatcher.java
index d976a6a88..c779d6c07 100644
--- a/game/client/src/test/java/TestItemModelDispatcher.java
+++ b/game/client/src/test/java/TestItemModelDispatcher.java
@@ -1,9 +1,5 @@
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.option.GameSettings;
-import net.minecraft.client.render.Font;
-import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
@@ -25,11 +21,7 @@ public class TestItemModelDispatcher {
         Colors.loadDummyColors();
 
         // Map model requires mc font reference
-        Minecraft mc = new Minecraft(null,true);
-        mc.gameSettings = new GameSettings(mc, mc.getMinecraftDir());
-        mc.texturePackList = new TexturePackList(mc, mc.getMinecraftDir());
-        mc.textureManager = new TextureManager(mc, mc.texturePackList, mc.gameSettings);
-        mc.font = new Font(mc, mc.gameSettings, mc.textureManager);
+        new Minecraft(Minecraft.getAppDir("minecraft-bta"), null,true);
 
         for (Map.Entry<NamespaceID, Item> e : Item.itemsMap.entrySet()) {
             Assertions.assertTrue(ItemModelDispatcher.getInstance().hasDispatch(e.getValue()), () -> "Item '" + e.getKey() + "' is not assigned a item model!");
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/Text.java b/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
index d5dfcc64e..fef4477b0 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
@@ -1,8 +1,9 @@
 package net.minecraft.core.lang.text;
 
 import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
 
-public abstract class Text {
+public abstract class Text implements CharSequence {
     public static Text text() {
         return new ChainText();
     }
@@ -35,4 +36,21 @@ public abstract class Text {
     public Text fmt(TextFormatting formatting, Text text) {
         return new ChainText(this, new FormattedText(formatting, text));
     }
+
+    // TODO consider a more optimized implementation if we keep this as a char sequence
+    @Override
+    public int length() {
+        return toString().length();
+    }
+
+    @Override
+    public char charAt(int index) {
+        return toString().charAt(index);
+    }
+
+    @NotNull
+    @Override
+    public CharSequence subSequence(int start, int end) {
+        return toString().subSequence(start, end);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/ChatLine.java b/game/core/src/main/java/net/minecraft/core/net/ChatLine.java
index 9a89e1b17..aebf3420a 100644
--- a/game/core/src/main/java/net/minecraft/core/net/ChatLine.java
+++ b/game/core/src/main/java/net/minecraft/core/net/ChatLine.java
@@ -4,12 +4,12 @@ package net.minecraft.core.net;
 public class ChatLine
 {
 
-    public ChatLine(String s)
+    public ChatLine(CharSequence s)
     {
         message = s;
         updateCounter = 0;
     }
 
-    public String message;
+    public CharSequence message;
     public int updateCounter;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java b/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
index 3da062e97..0a1236020 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
@@ -3,7 +3,9 @@ package net.minecraft.core.net.command;
 import org.jetbrains.annotations.Nullable;
 
 public class TextFormatting {
-	public static final TextFormatting[] FORMATTINGS = new TextFormatting[22];
+	public static final String FORMAT_CHARS = "0123456789abcdefklmnor+-";
+	public static final String FORMAT_REGEX = "§[0123456789abcdefklmnor+-]|§<(.*?)>";
+	public static final TextFormatting[] FORMATTINGS = new TextFormatting[24];
 	
 	public static final TextFormatting WHITE = new TextFormatting(0).setNames("White");
 	public static final TextFormatting ORANGE = new TextFormatting(1).setNames("Orange");
@@ -27,6 +29,8 @@ public class TextFormatting {
     public static final TextFormatting UNDERLINE = new TextFormatting(19).setNames("Underline");
     public static final TextFormatting ITALIC = new TextFormatting(20).setNames("Italic");
     public static final TextFormatting RESET = new TextFormatting(21).setNames("Reset");
+    public static final TextFormatting PUSH = new TextFormatting(22).setNames("Push");
+    public static final TextFormatting POP = new TextFormatting(23).setNames("Pop");
 
 	public static final char SPECIAL_CHAR = '\247';
 
@@ -37,7 +41,7 @@ public class TextFormatting {
 	public TextFormatting(int id) {
 		FORMATTINGS[id] = this;
 		this.id = id;
-		this.code = "0123456789abcdefklmnor".charAt(id);
+		this.code = FORMAT_CHARS.charAt(id);
 	}
 
 	public static @Nullable TextFormatting fromChar(final char c) {
@@ -66,7 +70,7 @@ public class TextFormatting {
 		return null;
 	}
 	public static String removeAllFormatting(String name){
-		return name.replaceAll("§[0123456789abcdefklmnor]|§<(.*?)>", "");
+		return name.replaceAll(FORMAT_REGEX, "");
 	}
 
     public static String formatted(String string, TextFormatting... formattings) {
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index 86f765de1..bc079d09f 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -242,6 +242,7 @@ gui.options.page.debug.button.open.biome_finder=Open Seed Viewer
 gui.options.page.debug.button.open.datadumper=Run Data Dumper
 gui.options.page.debug.button.open.sound_test=Open Sound Test
 gui.options.page.debug.button.open.texture_viewer=Open Texture Viewer
+gui.options.page.debug.button.open.font_tester=Open Font Test
 gui.options.page.debug.button.open.achievements=Open Achievements
 gui.options.page.debug.button.wipestats=Delete Stats
 gui.options.page.debug.button.unlockedall=Unlock all stats
